# Define the kmod package name here.
%define kmod_name qlcnic

# Define the QLogic serial number.
%define QLsn 141010

# If kversion isn't defined on the rpmbuild line, define it here.
%{!?kversion: %define kversion 3.10.0-123.el7.%{_target_cpu}}

Name:    %{kmod_name}-kmod
Version: 5.3.61.2
Release: 1%{?dist}
Group:   System Environment/Kernel
License: GPLv2
Summary: %{kmod_name} kernel module(s)
URL:     http://www.qlogic.com/

BuildRequires: redhat-rpm-config, perl
ExclusiveArch: x86_64

# Sources.
Source0:  http://filedownloads.qlogic.com/Files/TempDownlods/83661/%{kmod_name}-%{version}-%{QLsn}-QLogic.tgz
Source5:  GPL-v2.0.txt
Source10: kmodtool-%{kmod_name}-el7.sh

# Magic hidden here.
%{expand:%(sh %{SOURCE10} rpmtemplate %{kmod_name} %{kversion} "")}

# Disable the building of the debug package(s).
%define debug_package %{nil}

%description
This package provides the %{kmod_name} kernel module(s).
It is built to depend upon the specific ABI provided by a range of releases
of the same variant of the Linux kernel and not on any one specific build.

%prep
%setup -q -n %{kmod_name}-%{version}-QLogic
%{__tar} -zxf qlgc-%{kmod_name}-src-%{version}.tgz
%{__rm} -f *.tgz
%{__cp} -a %{kmod_name}-%{version}-src/*rhel7.0_3.10.0-123.el7.tgz .
%{__rm} -fr %{kmod_name}-%{version}-src
%{__tar} -zxf *rhel7*.tgz
echo "override %{kmod_name} * weak-updates/%{kmod_name}" > kmod-%{kmod_name}.conf

%build
pushd %{kmod_name}-%{version} >/dev/null
KSRC=%{_usrsrc}/kernels/%{kversion}
%{__make} -C "${KSRC}" %{?_smp_mflags} modules M=$PWD CONFIG_QLCNIC=m
popd >/dev/null

%install
%{__install} -d %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} %{kmod_name}-%{version}/%{kmod_name}.ko %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} -d %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} kmod-%{kmod_name}.conf %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} -d %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} %{SOURCE5} %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} %{kmod_name}-%{version}/INSTALL.%{kmod_name} %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/INSTALL.txt
%{__install} README_%{kmod_name}_QLOGIC.txt %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} RELEASE_%{kmod_name}_QLOGIC.txt %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} -d %{buildroot}%{_mandir}/man4/
%{__install} %{kmod_name}-%{version}/%{kmod_name}.4.gz %{buildroot}%{_mandir}/man4/

# Strip the modules(s).
find %{buildroot} -type f -name \*.ko -exec %{__strip} --strip-debug \{\} \;

# Sign the modules(s).
%if %{?_with_modsign:1}%{!?_with_modsign:0}
# If the module signing keys are not defined, define them here.
%{!?privkey: %define privkey %{_sysconfdir}/pki/SECURE-BOOT-KEY.priv}
%{!?pubkey: %define pubkey %{_sysconfdir}/pki/SECURE-BOOT-KEY.der}
for module in $(find %{buildroot} -type f -name \*.ko);
do %{__perl} /usr/src/kernels/%{kversion}/scripts/sign-file \
    sha256 %{privkey} %{pubkey} $module;
done
%endif

%clean
%{__rm} -rf %{buildroot}

%changelog
* Sat Dec 06 2014 Alan Bartlett <ajb@elrepo.org> - 5.3.61.2-1
- Updated to version 5.3.61.2

* Wed Oct 29 2014 Alan Bartlett <ajb@elrepo.org> - 5.3.55.7-1
- Updated to version 5.3.55.7

* Tue Jul 08 2014 Alan Bartlett <ajb@elrepo.org> - 0.0-1
- Initial el7 build of the kmod package.
